Package org.h2.expression

# Class Alias

java.lang.Object
org.h2.expression.Expression
org.h2.expression.Alias

All Implemented Interfaces:
  `HasSQL`, `Typed`

public final class Alias extends Expression
A column alias as in SELECT 'Hello' AS NAME ...

## Field Summary

### Fields inherited from class org.h2.expression.Expression

`AUTO_PARENTHESES, MAP_IN_AGGREGATE, MAP_IN_WINDOW, MAP_INITIAL, WITH_PARENTHESES, WITHOUT_PARENTHESES`

### Fields inherited from interface org.h2.util.HasSQL

`ADD_PLAN_INFORMATION, DEFAULT_SQL_FLAGS, NO_CASTS, QUOTE_ONLY_WHEN_REQUIRED, REPLACE_LOBS_FOR_TRACE, TRACE_SQL_FLAGS`

## Constructor Summary

Constructors
Constructor
Description
`Alias(Expression expression, String alias, boolean aliasColumnName)`

## Method Summary

Modifier and Type
Method
Description
`String`
`getAlias(SessionLocal session, int columnIndex)`
Get the alias name of a column or SQL expression if it is not an aliased expression.
`String`
`getColumnName(SessionLocal session, int columnIndex)`
Get the column name or alias name of this expression.
`String`
`getColumnNameForView(SessionLocal session, int columnIndex)`
Get the column name of this expression for a view.
`int`
`getCost()`
Estimate the cost to process the expression.
`Expression`
`getNonAliasExpression()`
Returns the main expression, skipping aliases.
`int`
`getNullable()`
Check whether this expression is a column and can store NULL.
`String`
`getSchemaName()`
Get the schema name, or null
`String`
`getTableName()`
Get the table name, or null
`TypeInfo`
`getType()`
Returns the data type.
`StringBuilder`
`getUnenclosedSQL(StringBuilder builder, int sqlFlags)`
Get the SQL statement of this expression.
`Value`
`getValue(SessionLocal session)`
Return the resulting value for the current row.
`boolean`
`isEverything(ExpressionVisitor visitor)`
Check if this expression and all sub-expressions can fulfill a criteria.
`boolean`
`isIdentity()`
Check if this is an identity column.
`void`
`mapColumns(ColumnResolver resolver, int level, int state)`
Map the columns of the resolver to expression columns.
`Expression`
`optimize(SessionLocal session)`
Try to optimize the expression.
`void`
`setEvaluatable(TableFilter tableFilter, boolean b)`
Tell the expression columns whether the table filter can return values now.
`void`
`updateAggregate(SessionLocal session, int stage)`
Update an aggregate value.

### Methods inherited from class org.h2.expression.Expression

`addFilterConditions, createIndexConditions, getBooleanValue, getEnclosedSQL, getNotIfPossible, getSQL, getSQL, getSQL, getSQL, getSubexpression, getSubexpressionCount, getTableAlias, getTypeIfStaticallyKnown, getWhenSQL, getWhenValue, isConstant, isNullConstant, isValueSet, isWhenConditionOperand, needParentheses, optimizeCondition, toString, writeExpressions, writeExpressions`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.h2.util.HasSQL

`getTraceSQL`

## Constructor Details

### Alias

public Alias(Expression expression, String alias, boolean aliasColumnName)

## Method Details

### getNonAliasExpression

public Expression getNonAliasExpression()
Description copied from class: `Expression`
Returns the main expression, skipping aliases.

Overrides:
  `getNonAliasExpression` in class `Expression`
Returns:
  the expression

### getValue

public Value getValue(SessionLocal session)
Description copied from class: `Expression`
Return the resulting value for the current row.

Specified by:
  `getValue` in class `Expression`
Parameters:
  `session` - the session
Returns:
  the result

### getType

public TypeInfo getType()
Description copied from class: `Expression`
Returns the data type. The data type may be unknown before the optimization phase.

Specified by:
  `getType` in interface `Typed`
Specified by:
  `getType` in class `Expression`
Returns:
  the data type

### mapColumns

public void mapColumns(ColumnResolver resolver, int level, int state)
Description copied from class: `Expression`
Map the columns of the resolver to expression columns.

Specified by:
  `mapColumns` in class `Expression`
Parameters:
  `resolver` - the column resolver
  `level` - the subquery nesting level
  `state` - current state for nesting checks, initial value is `Expression.MAP_INITIAL`

### optimize

public Expression optimize(SessionLocal session)
Description copied from class: `Expression`
Try to optimize the expression.

Specified by:
  `optimize` in class `Expression`
Parameters:
  `session` - the session
Returns:
  the optimized expression

### setEvaluatable

public void setEvaluatable(TableFilter tableFilter, boolean b)
Description copied from class: `Expression`
Tell the expression columns whether the table filter can return values now. This is used when optimizing the query.

Specified by:
  `setEvaluatable` in class `Expression`
Parameters:
  `tableFilter` - the table filter
  `b` - true if the table filter can return value

### isIdentity

public boolean isIdentity()
Description copied from class: `Expression`
Check if this is an identity column.

Overrides:
  `isIdentity` in class `Expression`
Returns:
  true if it is an identity column

### getUnenclosedSQL

public StringBuilder getUnenclosedSQL(StringBuilder builder, int sqlFlags)
Description copied from class: `Expression`
Get the SQL statement of this expression. This may not always be the original SQL statement, especially after optimization. Enclosing '(' and ')' are never appended.

Specified by:
  `getUnenclosedSQL` in class `Expression`
Parameters:
  `builder` - string builder
  `sqlFlags` - formatting flags
Returns:
  the specified string builder

### updateAggregate

public void updateAggregate(SessionLocal session, int stage)
Description copied from class: `Expression`
Update an aggregate value. This method is called at statement execution time. It is usually called once for each row, but if the expression is used multiple times (for example in the column list, and as part of the HAVING expression) it is called multiple times - the row counter needs to be used to make sure the internal state is only updated once.

Specified by:
  `updateAggregate` in class `Expression`
Parameters:
  `session` - the session
  `stage` - select stage

### getAlias

public String getAlias(SessionLocal session, int columnIndex)
Description copied from class: `Expression`
Get the alias name of a column or SQL expression if it is not an aliased expression.

Overrides:
  `getAlias` in class `Expression`
Parameters:
  `session` - the session
  `columnIndex` - 0-based column index
Returns:
  the alias name

### getColumnNameForView

public String getColumnNameForView(SessionLocal session, int columnIndex)
Description copied from class: `Expression`
Get the column name of this expression for a view.

Overrides:
  `getColumnNameForView` in class `Expression`
Parameters:
  `session` - the session
  `columnIndex` - 0-based column index
Returns:
  the column name for a view

### getNullable

public int getNullable()
Description copied from class: `Expression`
Check whether this expression is a column and can store NULL.

Overrides:
  `getNullable` in class `Expression`
Returns:
  whether NULL is allowed

### isEverything

public boolean isEverything(ExpressionVisitor visitor)
Description copied from class: `Expression`
Check if this expression and all sub-expressions can fulfill a criteria. If any part returns false, the result is false.

Specified by:
  `isEverything` in class `Expression`
Parameters:
  `visitor` - the visitor
Returns:
  if the criteria can be fulfilled

### getCost

public int getCost()
Description copied from class: `Expression`
Estimate the cost to process the expression. Used when optimizing the query, to calculate the query plan with the lowest estimated cost.

Specified by:
  `getCost` in class `Expression`
Returns:
  the estimated cost

### getSchemaName

public String getSchemaName()
Description copied from class: `Expression`
Get the schema name, or null

Overrides:
  `getSchemaName` in class `Expression`
Returns:
  the schema name

### getTableName

public String getTableName()
Description copied from class: `Expression`
Get the table name, or null

Overrides:
  `getTableName` in class `Expression`
Returns:
  the table name

### getColumnName

public String getColumnName(SessionLocal session, int columnIndex)
Description copied from class: `Expression`
Get the column name or alias name of this expression.

Overrides:
  `getColumnName` in class `Expression`
Parameters:
  `session` - the session
  `columnIndex` - 0-based column index
Returns:
  the column name